{
    "type": "minecraft:crafting_shaped",
    "pattern": [
        " T ",
        "trt",
        "sts"
    ],
    "key": {
        "t": {
            "item": "minecraft:tnt"
        },
        "r": {
            "item": "minecraft:redstone_block"
        },
        "s": {
            "item": "minecraft:stone"
        },
        "T": {
            "item": "minecraft:tripwire_hook"
        }
    },
    "result": {
        "item": "knowledge_book",
        "count": 1
    }
}